using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace WeaponMod
{
    public class WeaponMod
    {
        public static void Main()
        {

     //Doom Slayer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "DoomSlayer -DSM",
                    NameToOrderByOverride = "ZZ1",
                    DescriptionOverride = "Rip and Tear unitl it´s done.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("pplView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("pplskin.png");
                        var flesh = ModAPI.LoadTexture("pplflesh.png");
                        var bone = ModAPI.LoadTexture("pplbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(37, 44, 30); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(34, 36, 33); //second bruise colour. red by default
                        person.SetThirdBruiseColor(30, 30, 30); // third bruise colour. light yellow by default
                        person.SetBloodColour(50, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(54, 21, 21); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {

                             body.BaseStrength *= 1f;                          
                             body.Health *= 500f;
                             body.BreakingThreshold *= 12f;
                             body.transform.root.localScale *= 1f; 
                              body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                             {
                                                          ModAPI.LoadSound("1.wav"),
                                                          ModAPI.LoadSound("2.wav"),
                                                          ModAPI.LoadSound("3.wav"),
                                                          ModAPI.LoadSound("4.wav"), 
                                                          ModAPI.LoadSound("5.wav"),
                                                          ModAPI.LoadSound("6.wav"),  
                                                          ModAPI.LoadSound("7.wav"),
                                                          ModAPI.LoadSound("8.wav"),                                                                                  
                                                        }; 

                        }  
                    }
                }
            );

//Doom Imp
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Imp Demon -DSM",
                    NameToOrderByOverride = "ZZ1",
                    DescriptionOverride = "Rip Them and Tear Them",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("pplView2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("pplskin2.png");
                        var flesh = ModAPI.LoadTexture("pplflesh2.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, null, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );

//DOOM 2016 Super Shotgun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "DOOM (2016) SuperShotgun -DSM",
                    NameToOrderByOverride = "AAA1",
                    DescriptionOverride = "The only thing they fear.. IS YOU",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("SuperShotgunView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SuperShotgun.png", 1.7f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.2f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "12-gauge";
                        customCartridge.Damage *= 6f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 6f;
                        firearm.Cartridge = customCartridge;

firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Fire1.mp3"),
            };

 Instance.FixColliders();


                    }
                }
            );

            //doomslayer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "doomslayer -DOOM",
                    NameToOrderByOverride = "ZZ1",
                    DescriptionOverride = "Its Him",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("slay.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("doomslayer.png");
                        var flesh = ModAPI.LoadTexture("pplflesh.png");
                        var bone = ModAPI.LoadTexture("pplbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(1, 0, 1); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(20, 0, 20); //second bruise colour. red by default
                        person.SetThirdBruiseColor(50, 0, 50); // third bruise colour. light yellow by default
                        person.SetBloodColour(1, 0, 1); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.Health *= 85485484.6f;
                            body.InitialHealth *= 85485484.6f;
                            body.BreakingThreshold = Mathf.Infinity;
                            body.PhysicalBehaviour.Charge = 0f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 3f;
                            body.BloodDecal = null;
                            body.RegenerationSpeed += 10f;
                            body.Numbness *= 3f;
                            body.CirculationBehaviour.BloodFlow *= 0f;
                            body.ImpactPainMultiplier *= 0f;
                            body.IsLethalToBreak = false;
                            body.PhysicalBehaviour.ReflectsLasers = true;
                            body.PhysicalBehaviour.Properties.Flammability = 0f;
                            body.PhysicalBehaviour.Disintegratable = false;
                            body.PhysicalBehaviour.Deletable = false;    
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                             {
                                                          ModAPI.LoadSound("1.wav"),
                                                          ModAPI.LoadSound("2.wav"),
                                                          ModAPI.LoadSound("3.wav"),
                                                          ModAPI.LoadSound("4.wav"), 
                                                          ModAPI.LoadSound("5.wav"),
                                                          ModAPI.LoadSound("6.wav"),  
                                                          ModAPI.LoadSound("7.wav"),
                                                          ModAPI.LoadSound("8.wav"),                                                                                  
                                                        };                        
                        }
                    }
                }
            );


        }
    }
}